/*
 * GEMClip, a Clipboard Manager for FreeMiNT and MagiC.
 *
 * Copyright (C) 2011 Jean-Franois Lemaire (jflemaire@skynet.be)
 *
 * This file is part of GEMClip.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/* GEMDOS File Attributtes */
#define FA_READONLY 0x01
#define FA_HIDDEN 0x02
#define FA_SYSTEM 0x04
#define FA_VOLUME 0x08
#define FA_SUBDIR 0x10
#define FA_ARCHIVE 0x20
#define FA_PARDIR 0x40

int    update_manager      (int scraphdl, int dirhdl, GEMCLIP *manager, USERCONF *conf);
void   select_all_clips    (GEMCLIP *manager, int mode);
void   save_clips          (GEMCLIP *manager, int clipn);
void   append_clips        (GEMCLIP *manager, short item, int clipn);
void   merge_clips         (GEMCLIP *manager);
int    find_first_selected (GEMCLIP *manager);
int    selection           (CLIPS *clips[]);
void   delete_clips        (GEMCLIP *manager, USERCONF *conf);
int    write_clippath      (char *path, size_t pathsize, const char *clipbrd, int clipn);
void  define_clips         (const char *command);
void  deselect_all         (GEMCLIP *manager);
