/*
 * GEMClip, a Clipboard Manager for FreeMiNT and MagiC.
 *
 * Copyright (C) 2011 Jean-Franois Lemaire (jflemaire@skynet.be)
 *
 * This file is part of GEMClip.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include <wchar.h>

VdiHdl         open_virtual_workst   (short workin[], short workout[]);
char          *get_value             (FILE *file, const char *key, char value[], size_t size);
int            do_window_form        (OBJECT *tree, WINDOW *window, EVMULT_OUT *evmult_out, short event);
void           handle_mouse_rect     (GEMCLIP *manager, WINDOW *win, OBJECT *tree, BUBBLES *bubbles, EVMULT_IN *evmult_in, EVMULT_OUT *evmult_out);
short          handle_popup          (short handle, OBJECT *tree, OBJECT *popup, short object, int scrollmode, char *buffer, size_t size);
void           uncheck_prev_item     (OBJECT *menu);
void           resize_popup          (OBJECT *tree, int nitems, size_t width);
void           draw_window_form      (OBJECT *tree, short handle, GRECT *clip);
void           draw_icon             (OBJECT *tree, short icon, short width, short height, short whandle);
void           redraw_object         (short handle, OBJECT *tree, short object);
void           change_state          (short handle, OBJECT *tree, short object, int state);
void           clear_editfield       (OBJECT *tree, short object, short handle);
char          *add_trailing_backslash(char *str, size_t size);
void           remove_whitespace     (char *str);
void           write_popup_boxtext   (OBJECT *tree, short object, int value);
OBJECT        *get_gem_tree          (short ntree); 
char          *get_free_string       (short object);
char          *get_gstring           (short ntree, int16_t object);
long           get_number_from_label (OBJECT *tree, short object);
void           form_alert_string     (int button, const char *icon, const char *string1, const char *string2);
unsigned char  get_ascii_value       (int kreturn, int kmeta);
void           send_local_message    (short message, short msg3, short msg4, short msg5, short msg6, short msg7);
void           send_redraw_message   (short handle);
void           broadcast_window_draw (char *path);
void           broadcast_sc_changed  (void);
void           call_help             (short handle, OBJECT *tree, short object, char *avserver, const char *guide, const char *page, int os);
void           set_mouse_rect        (short handle, EVMULT_IN *evmult_in);
void          *xmalloc               (size_t memsize);
WINDOW        *init_window           (WINDOW *window);
void           sound_bell            (void);

struct window {
    short  handle;          // Window handle.
    VdiHdl wks;             // Vdi virtual workstation handle.
    short  workin[11];
    short  workout[57];
    short  wchar;
    short  hchar;
    short  wcell;
    short  hcell;
    int    icon;
    int    open;
    char   info[MBUFFER];   // The infoline string.
    short  strindex;        // Index of the G_STRING to display in the infoline.
};
